# Security

The following document describes various aspects of the Firedancer security program.

## Table of Contents

- [Bug Bounty Program](#Bug-Bounty-Program)
- [Third Party Security Audits](#Third-Party-Security-Audits)
- [Audit Contest](#Audit-Contest)

# Bug Bounty Program

Security-relevant bugs in Firedancer v0.1 should be submitted to our [Immunefi bug bounty program](https://immunefi.com/bug-bounty/firedancer/).
Under the terms and conditions of the program, you may be eligible for a reward.

Code outside the scope of the bug bounty program is still in development.
It is yet to go through more rigorous security testing and auditing.
If you find a bug outside the bug bounty program's scope, submit it as a [GitHub issue](https://github.com/firedancer-io/firedancer/issues).

## Third Party Security Audits

The Firedancer project engages third party firms to conduct independent security audits of Firedancer.

As these third-party audits are completed and issues are sufficiently addressed, we make those audit reports public.

- [Firedancer v0.1 Audit Reports](https://github.com/firedancer-io/audits)

## Audit Contest

Leading up to the mainnet launch of Firedancer v0.1, an [audit contest on Immunefi](https://github.com/immunefi-team/Bounty_Boosts/tree/main/Firedancer%20v0.1) was held from 10 July 2024 to 21 August 2024.